#include "automaton.cpp"
#include <stdio.h>

#define maxSize 10
#define maxIterations 10000

int pebbles[maxSize][maxSize], nextPebbles[maxSize][maxSize];

int main()
{
    freopen("automaton.dat", "r", stdin);
    freopen("automaton.sol", "w", stdout);

    int directions[4][2] = {
        {-1, 0}, // top
        {0, 1},  // right
        {1, 0},  // bottom
        {0, -1}  // left
    };

    int subproblem, size, A, B;
    scanf("%d %d %d %d", &subproblem, &size, &A, &B);
    for (int i = 0; i < size; i++)
        for (int j = 0; j < size; j++)
            pebbles[i][j] = nextPebbles[i][j] = 0;
    pebbles[0][0] = nextPebbles[0][0] = A;
    pebbles[0][size - 1] = nextPebbles[0][size - 1] = B;

    int iteration = 0;

    while (true)
    {
        iteration++;

        bool movement = false;

        for (int i = 0; i < size; i++)
            for (int j = 0; j < size; j++)
            {
                int move[4] = {0, 0, 0, 0};
                if (pebbles[i][j] > 0)
                    automaton(subproblem, size, i + 1, j + 1, pebbles[i][j], move[0], move[1], move[2], move[3]);
                int moveTotal = 0;
                for (int k = 0; k < 4; k++)
                {
                    if (move[k] < 0)
                    {
                        printf("  䒺  .\n");
                        return 0;
                    } else if (move[k] > 0)
                    {
                        int moveI = i + directions[k][0], moveJ = j + directions[k][1];
                        if (moveI < 0 || moveI == size || moveJ < 0 || moveJ == size)
                        {
                            printf("     .\n");
                            return 0;
                        }
                        nextPebbles[moveI][moveJ] += move[k];
                        moveTotal += move[k];
                        movement = true;
                    }
                }
                if (pebbles[i][j] < moveTotal)
                {
                    printf("   ,    .\n");
                    return 0;
                }
                nextPebbles[i][j] -= moveTotal;
            }

        if (! movement || iteration == maxIterations)
        {
            if (! movement)
                printf("%d %d\n", nextPebbles[size - 1][0], nextPebbles[size - 1][size - 1]);
            else
                printf("   %d .\n", maxIterations);
            printf("\n");
            for (int i = 0; i < size; i++)
            {
                for (int j = 0; j < size; j++)
                    printf(j == 0 ? "%d" : " %d", nextPebbles[i][j]);
                printf("\n");
            }
            return 0;
        }

        for (int i = 0; i < size; i++)
            for (int j = 0; j < size; j++)
                pebbles[i][j] = nextPebbles[i][j];
    }
}
