{$I automaton.pas}

const maxSize = 10;
      maxIterations = 10000;

var pebbles: array[1..maxSize, 1..maxSize] of longint;
    nextPebbles: array[1..maxSize, 1..maxSize] of longint;
    directions: array[1..4, 1..2] of longint = (
        (-1, 0), // top
        (0, 1),  // right
        (1, 0),  // bottom
        (0, -1)  // left
    );
    subproblem, size, A, B, i, j, k, iteration, moveTotal, moveI, moveJ: longint;
    movement: boolean;
    move: array[1..4] of longint;

begin
    assign(input, 'automaton.dat');
    assign(output, 'automaton.sol');
    reset(input);
    rewrite(output);

    read(subproblem, size, A, B);
    for i := 1 to size do
        for j := 1 to size do begin
            pebbles[i, j] := 0;
            nextPebbles[i, j] := 0;
        end;
    pebbles[1, 1] := A;
    nextPebbles[1, 1] := A;
    pebbles[1, size] := B;
    nextPebbles[1, size] := B;

    iteration := 0;

    while true do begin
        inc(iteration);

        movement := false;

        for i := 1 to size do
            for j := 1 to size do begin
                for k := 1 to 4 do
                    move[k] := 0;
                if pebbles[i, j] > 0 then
                    automaton(subproblem, size, i, j, pebbles[i][j], move[1], move[2], move[3], move[4]);
                moveTotal := 0;
                for k := 1 to 4 do begin
                    if move[k] < 0 then begin
                        writeln('Sproba pereklasty vidyemnu kilkist kamintsiv.');
                        halt;
                    end else if move[k] > 0 then begin
                        moveI := i + directions[k, 1];
                        moveJ := j + directions[k, 2];
                        if (moveI < 1) or (moveI > size) or (moveJ < 1) or (moveJ > size) then begin
                            writeln('Sproba pereklasty kamintsi za mezhi kvadrata.');
                            halt;
                        end;
                        inc(nextPebbles[moveI, moveJ], move[k]);
                        inc(moveTotal, move[k]);
                        movement := true;
                    end;
                end;
                if (pebbles[i, j] < moveTotal) then begin
                    writeln('Sproba pereklasty bilshe kamintsiv, nizh ye u klityntsi.');
                    halt;
                end;
                dec(nextPebbles[i, j], moveTotal);
            end;

        if (not movement) or (iteration = maxIterations) then begin
            if (not movement) then
                writeln(nextPebbles[size][1], ' ', nextPebbles[size][size])
            else
                writeln('Perevyshcheno obmezhennia u ', maxIterations, ' iteratsiy.');
            writeln;
            for i := 1 to size do begin
                for j := 1 to size do begin
                    if j > 1 then
                        write(' ');
                    write(nextPebbles[i, j]);
                end;
                writeln;
            end;
            halt;
        end;

        for i := 1 to size do
            for j := 1 to size do
                pebbles[i, j] := nextPebbles[i, j];
    end;

    close(input);
    close(output);
end.
